class UserAgent
  attr_reader :app_version
  attr_reader :device_model
  attr_reader :device_os_version
  attr_reader :device_platform
  attr_reader :string

  def initialize(user_agent_string)
    @string = user_agent_string
    parse_string
  end

  def valid?
    @parsed_successfully &&
      !@app_version.to_s.empty? &&
      !@device_model.to_s.empty? &&
      !@device_os_version.to_s.empty? &&
      !@device_platform.to_s.empty?
  end

  private

  def parse_string
    if match = @string.match(/\/([^ ]+) \(([^)]+)\)/)
      @app_version, rest = match.captures
      rest = rest.split(';')
      @device_platform = rest[0].strip
      @device_os_version = rest[1].strip
      @device_model = rest[2].strip
      @parsed_successfully = true
    end
  rescue Exception
    @parsed_successfully = false
  end
end